# SNMP Poller Input

NetObserv SNMP can poll devices for metrics, status and other telemetry using SNMP.

#### EF\_INPUT\_SNMP\_POLLER\_WORKER\_POOL\_SIZE

When objects are scheduled for SNMP polling, a pool of pollers is initialized to allow concurrent polls for that specific device. This configuration controls the maximum number of pollers allowed across all devices. If a device is scheduled and the total number of pollers exceeds this value, a warning will be logged while still initializing all pollers. The default size of this pool is 4 times the number of CPU threads (real cores + HT/SMT threads). This setting allows a specific pool size to be configured.

* Minimum Value
  * `1`
* Default
  * `CPU threads * 4`

#### EF\_INPUT\_SNMP\_POLLER\_ERROR\_HANDLING

This configuration determines the approach of the SNMP poller in managing SNMP Get request errors. There are three modes:

1. Full Error Handling: The SNMP poller will drop objects for all types of Get request errors for that object. However, this mode is not advised for production environments, as it may lead to unnecessary dropping of objects.
2. Partial Error Handling: In this mode, the SNMP poller drops objects only for errors that are not transient. This is more selective and avoids reacting to temporary issues.
3. No Error Handling: The SNMP poller will not drop any objects.

* Valid Values
  * `none`, `partial`, `full`
* Default
  * `partial`

#### EF\_INPUT\_SNMP\_DEVICE\_DEFINITIONS\_DIRECTORY\_PATH

This setting specifies the path to the directory where the [Device](/snmpcoll/configuration/def_devices.md) definitions files are located.

* Default
  * `/etc/elastiflow/snmp/devices`

#### EF\_INPUT\_SNMP\_DEVICE\_GROUP\_DEFINITIONS\_DIRECTORY\_PATH

This setting specifies the path to the directory where the [Device Group](/snmpcoll/configuration/snmp-definition-files/def_device_groups.md) definitions files are located.

* Default
  * `/etc/elastiflow/snmp/device_groups`

#### EF\_INPUT\_SNMP\_OBJECT\_GROUP\_DEFINITIONS\_DIRECTORY\_PATH

This setting specifies the path to the directory where the [Object Group](/snmpcoll/configuration/snmp-definition-files/def_object_groups.md) definitions files are located.

* Default
  * `/etc/elastiflow/snmp/object_groups`

#### EF\_INPUT\_SNMP\_OBJECT\_DEFINITIONS\_DIRECTORY\_PATH

This setting specifies the path to the directory where the [Object](/snmpcoll/configuration/snmp-definition-files/def_objects.md) definitions files are located.

* Default
  * `/etc/elastiflow/snmp/objects`

#### EF\_INPUT\_SNMP\_DEFAULTS\_DIRECTORY\_PATH

This setting specifies the path to the directory where the [Device](/snmpcoll/configuration/def_devices.md) default definition files are located.

* Default
  * `/etc/elastiflow/snmp/defaults`

#### EF\_INPUT\_SNMP\_PERSIST\_ENABLE

NetObserv SNMP can persist the discovered inventory of SNMP objects, preventing the need for the inventory to be rebuilt when the collector is restarted. This setting specifies whether this feature is enabled.

* Valid Values
  * `true`, `false`
* Default
  * `true`

#### EF\_INPUT\_SNMP\_PERSIST\_DIRECTORY\_PATH

When inventory persistence is enabled (`EF_INPUT_SNMP_PERSIST_ENABLE` is `true`), this setting specifies the path to the directory where the files will be written.

* Default
  * `/usr/share/elastiflow/snmpcoll`


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.elastiflow.com/snmpcoll/configuration/input_snmp.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
